/* $Id: clnycon2.cpp,v 1.1.1.1 1992/08/20 02:22:14 cvs Exp $
 *
 * Copyright (c) 1992 University of Alberta
 *
 * May be copied or modified under the terms of the GNU General Public
 * License.  See COPYING file for more information.
 */

#include <graphics.h>
#include <image.h>
#include <conio.h>

char* fname = "L:\\TGA\\COL06.TGA";
char* outname = "J:\\COL006.tga";

MemoryImage *image;

void RemoveGreen ()
  {
  int x, y, w, h, r, g, b;

  image->GetImageSize (w, h);

  for (y=0; y<h; y++)
    for (x=0; x<w; x++)
      {
      image->GetPixelTC (x, y, r, g, b);
      r *= 2;  if (r > 255) r = 255;
      r -= g;
      if (r < 0) r = 0;
      image->PutPixelTC (x, y, r, g, b);
      };
  };

void run ()
  {
  TGAFile *inimage = new TGAFile (fname, READ);
  image = new MemoryImage (8, 8, 0);

  image->LoadImage (inimage);
  delete inimage;
  image->DisplayImage (0, 0);

  image->Smooth (green, 5);
  image->Smooth (red, 3);
  RemoveGreen ();
  image->DisplayImage (0, 0);

  image->CalculateHistogram();
  image->SmoothHistogram();
  int i;  long maxv;
  maxv = image->GetHistogramValue (green, image->GetBackgroundIntensity(green))/50;
  setcolor (0xF0);
  for (i=0; i<256; i++)
    line (i, 479, i, 479-image->GetHistogramValue(green, i)/maxv);
  maxv = image->GetHistogramValue (red, image->GetBackgroundIntensity(red))/50;
  setcolor (0x0F);
  for (i=0; i<256; i++)
    line (i, 479, i, 479-image->GetHistogramValue(red, i)/maxv);

  image->EnhanceContrast (red, image->GetBackgroundIntensity (red),
			       image->GetMaximumIntensity (red));
  image->EnhanceContrast (green, image->GetBackgroundIntensity (green),
				 image->GetMaximumIntensity (green));
  image->ShiftIntensity (red, 1);
  image->Smooth (green, 5);
  image->Smooth (red, 5);
  image->DisplayImage (0, 0);

  TGAFile *outimage = new TGAFile (outname, WRITE);
  outimage -> SetPixelSize (24, 0);
  outimage -> LoadImage (image);
  delete outimage;

  delete image;
  };

void SetPalette()
  {
  int i;

  for (i=0; i<256; i++)
    setrgbpalette (i, (i&0x0F)<<2, (i&0xF0)>>2, 0);
  };

int huge detect()  {  return (2);  };

main ()
{
  int Gd = DETECT, Gm;
  int Drv;
  installuserdriver("Svga256",detect);
  initgraph(&Gd,&Gm,"P:\\BGI");
  SetPalette();

  run ();

  cout << (char) 0x07;
  getch();

  closegraph();
  return 0;
};
